:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3250,_3244/_3246,_3254):-(retract(dynamicVersion(_3250,_3244/_3246,_3268))->true;true),asserta(dynamicVersion(_3250,_3244/_3246,_3254)).
prim_assertFact('Dynamic.Dynamic'(_3362),'Prelude.()'):-retract(dynamicTime(_3372)),_3386 is _3372+1,assertz(dynamicTime(_3386)),_3362=..[_3400,_3406,_3412,_3418|_3420],_3448=..[_3400,_3386,0|_3420],assertz(user:_3448),logDynamicEvent(_3406,assertz,_3448).
prim_retractFact('Dynamic.Dynamic'(_3550),_3556):-_3550=..[_3560,_3566,_3572,_3578|_3580],_3608=..[_3560,_3596,_3602|_3580],reloadNewestDynamicVersionOf(_3560),retract(dynamicTime(_3618)),_3632 is _3618+1,assertz(dynamicTime(_3632)),call(user:_3608),isInTimeInterval(_3618,_3596,_3602),!,_3682=..[_3560,_3596,_3618|_3580],retract(user:_3608),!,logDynamicEvent(_3566,retract,_3608),assertz(user:_3682),_3556='Prelude.True'.
prim_retractFact(_3848,'Prelude.False').
prim_getDynamicKnowledge(_3884):-reloadNewestDynamicVersions,dynamicTime(_3888),term2partcall('Dynamic.isKnownAtTime'(_3888),1,_3884),(compileWithSharing(function)->makeShare(_3884,_3910);_3910=_3884).
prim_isKnownAtTime(_3988,'Dynamic.Dynamic'(_3984),'Prelude.True'):-_3984=..[_3996,_4002,_4008,_4014|_4016],_4044=..[_3996,_4032,_4038|_4016],call(user:_4044),isInTimeInterval(_3988,_4032,_4038).
isInTimeInterval(_4136,_4138,_4140):-_4136>=_4138,(_4140=0->true;_4136=<_4140).
logDynamicEvent('Dynamic.Temporary',_4232,_4234):-!.
logDynamicEvent('Dynamic.Persistent',_4290,_4292):-_4292=..[_4296,_4302,_4308|_4310],_4338=..[_4296,0,0|_4310],_4356=..[_4290,_4338],user:dynamicPredInfo(_4296/_4364,_4370),logDynamic(_4356,_4370).
logDynamic(_4460,_4462):-dir2tmplockfile(_4462,_4468),lockWithFileIfNotInTransaction(_4468),executeWithFinalize((dir2logfile(_4462,_4478),open(_4478,append,_4486),writeq(_4486,_4460),put_code(_4486,46),nl(_4486),flush_output(_4486),close(_4486),addChangePid(_4462)),unlockWithFileIfNotInTransaction(_4468)).
executeWithFinalize(_4624,_4626):-on_exception(_4634,_4624,(call(_4626),printError(_4634),!,fail)),!,call(_4626).
executeWithFinalize(_4722,_4724):-call(_4724),!,fail.
prim_startTransaction(_4786):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4848,initTransaction(_4786),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4848),fail)),!.
initTransaction(_4930):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4934)),_4930 is _4934+1,assertz(dynamicTime(_4930)),logAllDynamicPreds(startTransaction(_4930)).
prim_commitTransaction(_5034,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_5034)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5118):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5126),map1partialM(prim_dynamic:addChangePid(0),_5126),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5232):-findall(_5236,isDynamicDir(_5236),_5244),sort(_5244,_5232).
isDynamicDir(_5294):-user:dynamicPredInfo(_5298,_5294),\+_5294=''.
logAllDynamicPreds(_5360):-getDynamicDirs(_5364),map1partialM(prim_dynamic:logDynamic(_5360),_5364).
initializeDynamic:-user:dynamicPredInfo(_5424/_5426,_5432),initializeDynamic(_5432,_5424/_5426),fail.
initializeDynamic.
initializeDynamic('',_5502/_5504):-!,retractAllFacts(_5502/_5504).
initializeDynamic(_5578,_5572/_5574):-existsDirectory(_5578),!,checkDynSpec(_5578,_5572/_5574),setDynamicVersion(_5578,_5572/_5574,0),!.
initializeDynamic(_5680,_5682):-existsFile(_5680),!,appendAtom('ERROR: Directory "',_5680,_5694),appendAtom(_5694,'" for dynamic entries cannot be created!',_5702),writeErr(_5702),nlErr,!,fail.
initializeDynamic(_5800,_5794/_5796):-upDirectory(_5800,_5808),(existsDirectory(_5808)->createDynamicDir(_5800,_5794/_5796),setDynamicVersion(_5800,_5794/_5796,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5800),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5986,_5988):-atom_codes(_5986,_5994),append(_6004,[47|_6000],_5994),\+member(47,_6000),!,atom_codes(_5988,_6004).
upDirectory(_6094,'.').
checkDynSpec(_6136,_6130/_6132):-dir2specfile(_6136,_6144),existsFile(_6144),readPrologTermFile(_6144,_6154),dynamicSpec(_6130/_6132,_6154),!.
checkDynSpec(_6236,_6238):-appendAtom('ERROR: Directory "',_6236,_6246),appendAtom(_6246,'" contains no matching dynamic entries!',_6254),writeErr(_6254),nlErr,!,fail.
replayLogFile(_6340,_6334/_6336):-dir2tmplockfile(_6340,_6348),lockWithFileIfNotInTransaction(_6348),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6340,_6334/_6336),unlockWithFileIfNotInTransaction(_6348)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6456,_6450/_6452):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6456),writeErr('\'...'),nlErr;true),getRunTime(_6510),ensurePakcsVersion(_6456),dir2dbfile(_6456,_6520),dir2pofile(_6456,_6526),consultPrologorPOFile(_6520,_6526),dir2logfile(_6456,_6538),open(_6538,read,_6546),(atEndOfStream(_6546)->close(_6546);assert(replayStatus(unchanged)),repeat,on_exception(_6576,readAndReplay(_6546),((printError(_6576)->true;true),writeErr('ERROR during reading of '),writeErr(_6538),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6546),retract(replayStatus(_6640)),writeNewDatabaseIfChanged(_6450/_6452,_6456,_6640)),updateDynFactsIfNecessary(_6456,_6450/_6452),readDynamicVersion(_6456,_6712),setDynamicVersion(_6456,_6450/_6452,_6712),writeChangePids(_6456,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6746),_6756 is _6746-_6510,writeErr(_6756),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6938):-readPAKCSVersion(_6938,_6944),_6944=pakcsVersion(_6948,_6950),prologMajor(_6960),\+_6960=_6950,dir2pofile(_6938,_6976),(existsFile(_6976)->deleteFile(_6976);true),writePAKCSVersion(_6938),!.
ensurePakcsVersion(_7080).
isCurrentPakcsVersion(_7106):-readPAKCSVersion(_7106,_7112),compilerVersion(_7116),!,(_7112=compilerVersion(_7116)->writePAKCSVersion(_7106);_7112=pakcsVersion(_7116,_7142)).
readPAKCSVersion(_7210,_7212):-dir2pakcsversionfile(_7210,_7218),existsFile(_7218),readPrologTermFile(_7218,_7212).
writePAKCSVersion(_7286):-dir2pakcsversionfile(_7286,_7292),compilerVersion(_7296),prologMajor(_7300),writePrologTermFile(_7292,pakcsVersion(_7296,_7300)).
updateDynFactsIfNecessary(_7368,_7370):-isCurrentPakcsVersion(_7368),!.
updateDynFactsIfNecessary(_7432,_7426/_7428):-compilerVersion(_7438),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7432),writeErr('\' to compiler version '),writeErr(_7438),writeErr(...),nlErr;true),updateDynFacts(_7426/_7428),writeNewDatabaseIfChanged(_7426/_7428,_7432,changed),writePAKCSVersion(_7432).
updateDynFactsIfNecessary(_7604,_7606).
updateDynFacts(_7640/_7642):-functor(_7650,_7640,_7642),functor(_7658,_7640,_7642),retract(user:_7650),arg(1,_7650,_7680),arg(1,_7658,_7680),arg(2,_7650,_7696),arg(2,_7658,_7696),translateDynFactArgs(3,_7642,_7650,_7658),asserta(user:_7658),fail.
updateDynFacts(_7816).
translateDynFactArgs(_7842,_7844,_7846,_7848):-_7842>_7844,!.
translateDynFactArgs(_7922,_7924,_7926,_7928):-arg(_7922,_7926,_7936),translateDynFactArg(_7936,_7942),arg(_7922,_7928,_7942),_7960 is _7922+1,translateDynFactArgs(_7960,_7924,_7926,_7928).
translateDynFactArg(_8058,_8058):-var(_8058),!.
translateDynFactArg(_8116,_8116):-number(_8116),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8654,_8656):-atomic(_8654),atom_codes(_8654,[40|_8666]),!,appendAtom('Prelude.',_8654,_8656).
translateDynFactArg(_8744,_8746):-atom(_8744),atom_codes(_8744,[39|_8756]),!,(_8756=[_8766]->char_int(_8746,_8766);_8756=[78,85,76]->char_int(_8746,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8908,_8908):-atomic(_8908),!.
translateDynFactArg(_8966,_8968):-functor(_8966,_8974,_8976),translateDynFactArg(_8974,_8982),functor(_8968,_8982,_8976),translateDynFactArgs(1,_8976,_8966,_8968).
writeNewDatabaseIfChanged(_9064/_9066,_9072,changed):-!,dir2dbfile(_9072,_9080),dir2pofile(_9072,_9086),dir2logfile(_9072,_9092),appendAtom(_9080,'.bak',_9100),tell(_9100),writeq((:-dynamic _9064/_9066)),put_code(46),nl,listing(user:_9064/_9066),told,try_save_predicates(_9064/_9066,_9086),renameFile(_9100,_9080),appendAtom(_9092,'.bak',_9168),renameFile(_9092,_9168),appendAtom('touch ',_9092,_9182),shellCmd(_9182),readDynamicVersion(_9072,_9192),_9202 is _9192+1,writeDynamicVersion(_9072,_9202),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9412/_9414,_9420,_9422):-dir2logfile(_9420,_9428),appendAtom(_9428,'.bak',_9436),renameFile(_9428,_9436),appendAtom('touch ',_9428,_9450),shellCmd(_9450).
readAndReplay(_9532):-atEndOfStream(_9532),!.
readAndReplay(_9580):-read(_9580,_9586),replayEvent(_9580,_9586).
replayEvent(_9636,end_of_file):-!.
replayEvent(_9688,startTransaction(_9684)):-readAndReplayTransaction(_9688,_9684,[]),!,fail.
replayEvent(_9756,_9758):-retract(replayStatus(_9762)),assert(replayStatus(changed)),call(user:_9758),!,fail.
readAndReplayTransaction(_9854,_9856,_9858):-atEndOfStream(_9854),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9856),nlErr;true).
readAndReplayTransaction(_9966,_9968,_9970):-read(_9966,_9976),(_9976=commitTransaction(_9968)->callRevList(_9970);_9976=abortTransaction->true;readAndReplayTransaction(_9966,_9968,[_9976|_9970])),!.
callRevList([]).
callRevList([_10126|_10128]):-callRevList(_10128),retract(replayStatus(_10140)),assert(replayStatus(changed)),call(user:_10126).
startTransaction(_10218).
commitTransaction(_10244).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10282),map1M(prim_dynamic:lockDynamicDir,_10282).
lockDynamicDir(_10328):-dir2lockfile(_10328,_10334),lockWithFile(_10334).
lockWithFileIfNotInTransaction(_10382):-insideTransaction->true;lockWithFile(_10382).
lockWithFile(_10436):-appendAtom('lockfile-create --lock-name ',_10436,_10444),(existsFile(_10436),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10436),writeErr('\'...'),nlErr;true),shellCmd(_10444),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10562),map1M(prim_dynamic:unlockDynamicDir,_10562).
unlockDynamicDir(_10608):-dir2lockfile(_10608,_10614),unlockWithFile(_10614).
unlockWithFileIfNotInTransaction(_10662):-insideTransaction->true;unlockWithFile(_10662).
unlockWithFile(_10716):-existsFile(_10716),!,appendAtom('lockfile-remove --lock-name ',_10716,_10728),shellCmd(_10728).
unlockWithFile(_10788).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10814/_10816,_10822),dynamicVersion(_10822,_10814/_10816,_10842),reloadNewestDynamicVersion(_10822,_10814/_10816,_10842),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10914):-dynamicVersion(_10924,_10914/_10920,_10928),!,reloadNewestDynamicVersion(_10924,_10914/_10920,_10928).
reloadNewestDynamicVersionOf(_10992).
reloadNewestDynamicVersion(_11024,_11018/_11020,0):-!,retractAllFacts(_11018/_11020),replayLogFile(_11024,_11018/_11020),!.
reloadNewestDynamicVersion(_11128,_11122/_11124,_11132):-readDynamicVersion(_11128,_11138),\+_11132=_11138,!,retractAllFacts(_11122/_11124),replayLogFile(_11128,_11122/_11124),!.
reloadNewestDynamicVersion(_11254,_11256,_11258):-readChangePids(_11254,_11264),currentPID(_11268),(_11264=[];_11264=[_11268]),!.
reloadNewestDynamicVersion(_11370,_11364/_11366,_11374):-retractAllFacts(_11364/_11366),replayLogFile(_11370,_11364/_11366).
createDynamicDir(_11462,_11456/_11458):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11462),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11462,_11520),shellCmd(_11520),dir2logfile(_11462,_11530),appendAtom('touch ',_11530,_11538),shellCmd(_11538),dir2dbfile(_11462,_11548),appendAtom('touch ',_11548,_11556),shellCmd(_11556),dir2specfile(_11462,_11566),dynamicSpec(_11456/_11458,_11578),writePrologTermFile(_11566,_11578),writePAKCSVersion(_11462).
readPrologTermFile(_11706,_11708):-open(_11706,read,_11716),read(_11716,_11708),close(_11716).
writePrologTermFile(_11784,_11786):-open(_11784,write,_11794),writeq(_11794,_11786),put_code(_11794,46),nl(_11794),flush_output(_11794),close(_11794).
readDynamicVersion(_11894,_11896):-dir2versionfile(_11894,_11902),existsFile(_11902),!,on_exception(_11922,readPrologTermFile(_11902,_11896),_11896=0).
readDynamicVersion(_11990,1).
writeDynamicVersion(_12026,_12028):-dir2versionfile(_12026,_12034),writePrologTermFile(_12034,_12028).
readChangePids(_12092,_12094):-dir2changepidsfile(_12092,_12100),existsFile(_12100),!,on_exception(_12126,readPrologTermFile(_12100,_12094),_12094=[0]).
readChangePids(_12194,[]).
writeChangePids(_12230,_12232):-dir2changepidsfile(_12230,_12238),writePrologTermFile(_12238,_12232).
addChangePid(_12296):-currentPID(_12300),addChangePid(_12300,_12296).
addChangePid(_12350,_12352):-readChangePids(_12352,_12358),(member(_12350,_12358)->true;writeChangePids(_12352,[_12350|_12358])),!.
dynamicSpec(_12446/_12448,dynamicPredicate(_12446,_12448)).
retractDeadDynamicFacts(_12494/_12496):-length(_12504,_12496),_12516=..[_12494|_12504],_12504=[_12522,_12528|_12530],dynamicTime(_12540),call(user:_12516),_12528>0,_12540>_12528,retract(user:_12516),fail.
retractDeadDynamicFacts(_12658).
dir2logfile(_12684,_12686):-appendAtom(_12684,'/eventlog',_12686).
dir2lockfile(_12740,_12742):-appendAtom(_12740,'/LOCK',_12742).
dir2tmplockfile(_12796,_12798):-appendAtom(_12796,'/LOCK',_12798).
dir2dbfile(_12852,_12854):-appendAtom(_12852,'/database.pl',_12854).
dir2pofile(_12908,_12910):-appendAtom(_12908,'/dbpred.po',_12910).
dir2specfile(_12964,_12966):-appendAtom(_12964,'/spec',_12966).
dir2pakcsversionfile(_13020,_13022):-appendAtom(_13020,'/pakcsversion',_13022).
dir2versionfile(_13076,_13078):-appendAtom(_13076,'/version',_13078).
dir2changepidsfile(_13132,_13134):-appendAtom(_13132,'/changepids',_13134).
